Skip to content

Meta memory space

Use the endpoints described below to manage meta memory spaces, which represent memory spaces for role-based access control (rbac) purposes.

Get a list of users, groups by meta memory space ID

Operation path: GET /api/v2/metaMemorySpaces/{metaMemorySpaceId}/sharedRoles/

Authentication requirements: BearerAuth

Get a list of users, groups, and organizations with access to this meta memory space.

Parameters

Name In Type Required Description
id query string false Only return roles for a user, group or organization with this identifier.
offset query integer true This many results will be skipped
limit query integer true At most this many results are returned
name query string false Only return roles for a user, group or organization with this name.
shareRecipientType query string false The list of access controls for recipients with this type.
metaMemorySpaceId path string true The ID of the meta memory space.

Enumerated Values

Parameter Value
shareRecipientType [user, group, organization, externalApplication]

Example responses

200 Response

{
  "properties": {
    "count": {
      "description": "The number of items returned.",
      "type": "integer"
    },
    "data": {
      "description": "The access control list.",
      "items": {
        "properties": {
          "id": {
            "description": "The identifier of the recipient.",
            "type": "string"
          },
          "name": {
            "description": "The name of the recipient.",
            "type": "string"
          },
          "role": {
            "description": "The role of the recipient on this entity.",
            "enum": [
              "ADMIN",
              "CONSUMER",
              "DATA_SCIENTIST",
              "EDITOR",
              "OBSERVER",
              "OWNER",
              "READ_ONLY",
              "READ_WRITE",
              "USER"
            ],
            "type": "string"
          },
          "scimIdpName": {
            "description": "The scim identity provider name. applicable to user and group recipients.",
            "type": [
              "string",
              "null"
            ],
            "x-versionadded": "v2.46"
          },
          "scimManaged": {
            "description": "Whether the recipient is scim-managed. applicable to user and group recipients.",
            "type": "boolean",
            "x-versionadded": "v2.46"
          },
          "shareRecipientType": {
            "description": "The type of the recipient.",
            "enum": [
              "user",
              "group",
              "organization",
              "externalApplication"
            ],
            "type": "string"
          }
        },
        "required": [
          "id",
          "name",
          "role",
          "shareRecipientType"
        ],
        "type": "object"
      },
      "maxItems": 1000,
      "type": "array"
    },
    "next": {
      "description": "The url pointing to the next page.",
      "type": [
        "string",
        "null"
      ]
    },
    "previous": {
      "description": "The url pointing to the previous page.",
      "type": [
        "string",
        "null"
      ]
    },
    "totalCount": {
      "description": "The total number of items matching the condition.",
      "type": "integer"
    }
  },
  "required": [
    "count",
    "data",
    "next",
    "previous",
    "totalCount"
  ],
  "type": "object"
}

Responses

Status Meaning Description Schema
200 OK none SharingListV2Response

Share a meta memory space source by meta memory space ID

Operation path: PATCH /api/v2/metaMemorySpaces/{metaMemorySpaceId}/sharedRoles/

Authentication requirements: BearerAuth

Share a meta memory space source with a user, group, or organization.

Body parameter

{
  "properties": {
    "note": {
      "default": "",
      "description": "A note to Go with the project share.",
      "maxLength": 512,
      "type": "string"
    },
    "operation": {
      "description": "Name of the action being taken. the only operation is 'updateroles'.",
      "enum": [
        "updateRoles"
      ],
      "type": "string"
    },
    "roles": {
      "description": "Array of grantaccesscontrol objects., up to maximum 100 objects.",
      "items": {
        "oneOf": [
          {
            "properties": {
              "role": {
                "description": "The role of the recipient on this entity.",
                "enum": [
                  "ADMIN",
                  "CONSUMER",
                  "DATA_SCIENTIST",
                  "EDITOR",
                  "NO_ROLE",
                  "OBSERVER",
                  "OWNER",
                  "READ_ONLY",
                  "READ_WRITE",
                  "USER"
                ],
                "type": "string"
              },
              "shareRecipientType": {
                "description": "Describes the recipient type — one of user, group, organization, or externalapplication.",
                "enum": [
                  "user",
                  "group",
                  "organization",
                  "externalApplication"
                ],
                "type": "string"
              },
              "username": {
                "description": "Username of the user to update the access role for.",
                "type": "string"
              }
            },
            "required": [
              "role",
              "shareRecipientType",
              "username"
            ],
            "type": "object"
          },
          {
            "properties": {
              "id": {
                "description": "The ID of the recipient.",
                "type": "string"
              },
              "role": {
                "description": "The role of the recipient on this entity.",
                "enum": [
                  "ADMIN",
                  "CONSUMER",
                  "DATA_SCIENTIST",
                  "EDITOR",
                  "NO_ROLE",
                  "OBSERVER",
                  "OWNER",
                  "READ_ONLY",
                  "READ_WRITE",
                  "USER"
                ],
                "type": "string"
              },
              "shareRecipientType": {
                "description": "Describes the recipient type — one of user, group, organization, or externalapplication.",
                "enum": [
                  "user",
                  "group",
                  "organization",
                  "externalApplication"
                ],
                "type": "string"
              }
            },
            "required": [
              "id",
              "role",
              "shareRecipientType"
            ],
            "type": "object"
          }
        ]
      },
      "maxItems": 100,
      "minItems": 1,
      "type": "array"
    },
    "sendNotification": {
      "default": false,
      "description": "Send a notification?",
      "type": "boolean"
    }
  },
  "required": [
    "operation",
    "roles"
  ],
  "type": "object",
  "x-versionadded": "v2.47"
}

Parameters

Name In Type Required Description
metaMemorySpaceId path string true The ID of the meta memory space.
body body MetaMemorySpaceSharingUpdateOrRemove false none

Responses

Status Meaning Description Schema
204 No Content The roles were updated successfully. None
422 Unprocessable Entity The request was formatted improperly. None

Schemas

AccessControlV2

{
  "properties": {
    "id": {
      "description": "The identifier of the recipient.",
      "type": "string"
    },
    "name": {
      "description": "The name of the recipient.",
      "type": "string"
    },
    "role": {
      "description": "The role of the recipient on this entity.",
      "enum": [
        "ADMIN",
        "CONSUMER",
        "DATA_SCIENTIST",
        "EDITOR",
        "OBSERVER",
        "OWNER",
        "READ_ONLY",
        "READ_WRITE",
        "USER"
      ],
      "type": "string"
    },
    "scimIdpName": {
      "description": "The scim identity provider name. applicable to user and group recipients.",
      "type": [
        "string",
        "null"
      ],
      "x-versionadded": "v2.46"
    },
    "scimManaged": {
      "description": "Whether the recipient is scim-managed. applicable to user and group recipients.",
      "type": "boolean",
      "x-versionadded": "v2.46"
    },
    "shareRecipientType": {
      "description": "The type of the recipient.",
      "enum": [
        "user",
        "group",
        "organization",
        "externalApplication"
      ],
      "type": "string"
    }
  },
  "required": [
    "id",
    "name",
    "role",
    "shareRecipientType"
  ],
  "type": "object"
}

Properties

Name Type Required Restrictions Description
id string true The identifier of the recipient.
name string true The name of the recipient.
role string true The role of the recipient on this entity.
scimIdpName string,null false The scim identity provider name. applicable to user and group recipients.
scimManaged boolean false Whether the recipient is scim-managed. applicable to user and group recipients.
shareRecipientType string true The type of the recipient.

Enumerated Values

Property Value
role [ADMIN, CONSUMER, DATA_SCIENTIST, EDITOR, OBSERVER, OWNER, READ_ONLY, READ_WRITE, USER]
shareRecipientType [user, group, organization, externalApplication]

GrantAccessControlWithId

{
  "properties": {
    "id": {
      "description": "The ID of the recipient.",
      "type": "string"
    },
    "role": {
      "description": "The role of the recipient on this entity.",
      "enum": [
        "ADMIN",
        "CONSUMER",
        "DATA_SCIENTIST",
        "EDITOR",
        "NO_ROLE",
        "OBSERVER",
        "OWNER",
        "READ_ONLY",
        "READ_WRITE",
        "USER"
      ],
      "type": "string"
    },
    "shareRecipientType": {
      "description": "Describes the recipient type — one of user, group, organization, or externalapplication.",
      "enum": [
        "user",
        "group",
        "organization",
        "externalApplication"
      ],
      "type": "string"
    }
  },
  "required": [
    "id",
    "role",
    "shareRecipientType"
  ],
  "type": "object"
}

Properties

Name Type Required Restrictions Description
id string true The ID of the recipient.
role string true The role of the recipient on this entity.
shareRecipientType string true Describes the recipient type — one of user, group, organization, or externalapplication.

Enumerated Values

Property Value
role [ADMIN, CONSUMER, DATA_SCIENTIST, EDITOR, NO_ROLE, OBSERVER, OWNER, READ_ONLY, READ_WRITE, USER]
shareRecipientType [user, group, organization, externalApplication]

GrantAccessControlWithUsername

{
  "properties": {
    "role": {
      "description": "The role of the recipient on this entity.",
      "enum": [
        "ADMIN",
        "CONSUMER",
        "DATA_SCIENTIST",
        "EDITOR",
        "NO_ROLE",
        "OBSERVER",
        "OWNER",
        "READ_ONLY",
        "READ_WRITE",
        "USER"
      ],
      "type": "string"
    },
    "shareRecipientType": {
      "description": "Describes the recipient type — one of user, group, organization, or externalapplication.",
      "enum": [
        "user",
        "group",
        "organization",
        "externalApplication"
      ],
      "type": "string"
    },
    "username": {
      "description": "Username of the user to update the access role for.",
      "type": "string"
    }
  },
  "required": [
    "role",
    "shareRecipientType",
    "username"
  ],
  "type": "object"
}

Properties

Name Type Required Restrictions Description
role string true The role of the recipient on this entity.
shareRecipientType string true Describes the recipient type — one of user, group, organization, or externalapplication.
username string true Username of the user to update the access role for.

Enumerated Values

Property Value
role [ADMIN, CONSUMER, DATA_SCIENTIST, EDITOR, NO_ROLE, OBSERVER, OWNER, READ_ONLY, READ_WRITE, USER]
shareRecipientType [user, group, organization, externalApplication]

MetaMemorySpaceSharingUpdateOrRemove

{
  "properties": {
    "note": {
      "default": "",
      "description": "A note to Go with the project share.",
      "maxLength": 512,
      "type": "string"
    },
    "operation": {
      "description": "Name of the action being taken. the only operation is 'updateroles'.",
      "enum": [
        "updateRoles"
      ],
      "type": "string"
    },
    "roles": {
      "description": "Array of grantaccesscontrol objects., up to maximum 100 objects.",
      "items": {
        "oneOf": [
          {
            "properties": {
              "role": {
                "description": "The role of the recipient on this entity.",
                "enum": [
                  "ADMIN",
                  "CONSUMER",
                  "DATA_SCIENTIST",
                  "EDITOR",
                  "NO_ROLE",
                  "OBSERVER",
                  "OWNER",
                  "READ_ONLY",
                  "READ_WRITE",
                  "USER"
                ],
                "type": "string"
              },
              "shareRecipientType": {
                "description": "Describes the recipient type — one of user, group, organization, or externalapplication.",
                "enum": [
                  "user",
                  "group",
                  "organization",
                  "externalApplication"
                ],
                "type": "string"
              },
              "username": {
                "description": "Username of the user to update the access role for.",
                "type": "string"
              }
            },
            "required": [
              "role",
              "shareRecipientType",
              "username"
            ],
            "type": "object"
          },
          {
            "properties": {
              "id": {
                "description": "The ID of the recipient.",
                "type": "string"
              },
              "role": {
                "description": "The role of the recipient on this entity.",
                "enum": [
                  "ADMIN",
                  "CONSUMER",
                  "DATA_SCIENTIST",
                  "EDITOR",
                  "NO_ROLE",
                  "OBSERVER",
                  "OWNER",
                  "READ_ONLY",
                  "READ_WRITE",
                  "USER"
                ],
                "type": "string"
              },
              "shareRecipientType": {
                "description": "Describes the recipient type — one of user, group, organization, or externalapplication.",
                "enum": [
                  "user",
                  "group",
                  "organization",
                  "externalApplication"
                ],
                "type": "string"
              }
            },
            "required": [
              "id",
              "role",
              "shareRecipientType"
            ],
            "type": "object"
          }
        ]
      },
      "maxItems": 100,
      "minItems": 1,
      "type": "array"
    },
    "sendNotification": {
      "default": false,
      "description": "Send a notification?",
      "type": "boolean"
    }
  },
  "required": [
    "operation",
    "roles"
  ],
  "type": "object",
  "x-versionadded": "v2.47"
}

Properties

Name Type Required Restrictions Description
note string false maxLength: 512
A note to Go with the project share.
operation string true Name of the action being taken. the only operation is 'updateroles'.
roles [oneOf] true maxItems: 100
minItems: 1
Array of grantaccesscontrol objects., up to maximum 100 objects.

oneOf

Name Type Required Restrictions Description
» anonymous GrantAccessControlWithUsername false none

xor

Name Type Required Restrictions Description
» anonymous GrantAccessControlWithId false none

continued

Name Type Required Restrictions Description
sendNotification boolean false Send a notification?

Enumerated Values

Property Value
operation updateRoles

SharingListV2Response

{
  "properties": {
    "count": {
      "description": "The number of items returned.",
      "type": "integer"
    },
    "data": {
      "description": "The access control list.",
      "items": {
        "properties": {
          "id": {
            "description": "The identifier of the recipient.",
            "type": "string"
          },
          "name": {
            "description": "The name of the recipient.",
            "type": "string"
          },
          "role": {
            "description": "The role of the recipient on this entity.",
            "enum": [
              "ADMIN",
              "CONSUMER",
              "DATA_SCIENTIST",
              "EDITOR",
              "OBSERVER",
              "OWNER",
              "READ_ONLY",
              "READ_WRITE",
              "USER"
            ],
            "type": "string"
          },
          "scimIdpName": {
            "description": "The scim identity provider name. applicable to user and group recipients.",
            "type": [
              "string",
              "null"
            ],
            "x-versionadded": "v2.46"
          },
          "scimManaged": {
            "description": "Whether the recipient is scim-managed. applicable to user and group recipients.",
            "type": "boolean",
            "x-versionadded": "v2.46"
          },
          "shareRecipientType": {
            "description": "The type of the recipient.",
            "enum": [
              "user",
              "group",
              "organization",
              "externalApplication"
            ],
            "type": "string"
          }
        },
        "required": [
          "id",
          "name",
          "role",
          "shareRecipientType"
        ],
        "type": "object"
      },
      "maxItems": 1000,
      "type": "array"
    },
    "next": {
      "description": "The url pointing to the next page.",
      "type": [
        "string",
        "null"
      ]
    },
    "previous": {
      "description": "The url pointing to the previous page.",
      "type": [
        "string",
        "null"
      ]
    },
    "totalCount": {
      "description": "The total number of items matching the condition.",
      "type": "integer"
    }
  },
  "required": [
    "count",
    "data",
    "next",
    "previous",
    "totalCount"
  ],
  "type": "object"
}

Properties

Name Type Required Restrictions Description
count integer true The number of items returned.
data [AccessControlV2] true maxItems: 1000
The access control list.
next string,null true The url pointing to the next page.
previous string,null true The url pointing to the previous page.
totalCount integer true The total number of items matching the condition.